var langStrings = new Object();
var currentLanguage = "";
var currentPresentation = "";
var currentPage = 1;
var pageCount = 0;
var languageToApply = "";

function startEngine()
{	
	$("#next_button").click(nextPage);
	$("#home_button").click(firstPage);
	$("#prev_button").click(prevPage);
	
	$("#about").click(function(){
			$("#darkbg").show();
			$("#info").show();
			$("#info").animate({
				top: "10%"
			},500);
			$("#darkbg").animate({
				opacity:.7
			},500);
		});
		//hide the info box
		$("#darkbg").click(function(){
			
			$("#info").animate({
				top: "100%"
			},500);
			$("#darkbg").animate({
				opacity:.0
			},500,function(){
				$("#darkbg").hide();
				$("#info").hide();
			});
		});
	$("#intfrag").click(function(){loadPresentation("intfrag");});
	$("#extfrag").click(function(){loadPresentation("extfrag");});
	$(document).keyup(function(event) {
		if(event.keyCode == 37)
			prevPage();
		if(event.keyCode == 39)
			nextPage();

});
}

function updateLanguages()
{
	var availableLanguages = "";
	for (var prop in langStrings) 
	{
		if (langStrings.hasOwnProperty(prop))		
			availableLanguages += "<a href=\"javascript:applyLanguage('"+prop+"');\"><img width='37px' height='25px' src='"+langStrings[prop].flagUrl+"' title='"+langStrings[prop].language+"'/></a>&nbsp;&nbsp;";
	}
	$( "#header" ).html(availableLanguages);
}

function onLoadLanguage()
{
	updateLanguages();
	
	if(languageToApply != "" && langStrings.hasOwnProperty(languageToApply))
	{
		currentLanguage = languageToApply;
		languageToApply = "";		
	}
	else
	{
		currentLanguage = localStorage.getItem("language");	
	
		if(currentLanguage === null)
			currentLanguage = "pt-BR";		
	}
	applyLanguage(currentLanguage);		
}

function applyLanguage(langName)
{
	currentLanguage = langName;
	localStorage.setItem("language", currentLanguage);
	for (var prop in langStrings[currentLanguage]) 
	{
		if (langStrings[currentLanguage].hasOwnProperty(prop))
		{
			if(prop.toString().lastIndexOf("img_") === 0)
				$( "#"+prop ).html("<img src='"+langStrings[currentLanguage][prop]+"' style='height:90%;'/>");
			else		
				$( "#"+prop ).text(langStrings[currentLanguage][prop]);
		}				
	}
	document.title = langStrings[currentLanguage].document_title;
	$("#about").prop('title', langStrings[currentLanguage].about_title);
}

function loadLanguage(langName)
{
	var head = document.getElementsByTagName('head')[0];
    var script = document.createElement('script');
    script.type = 'text/javascript';
    script.src = "lang/"+langName+".js";
	script.onreadystatechange = onLoadLanguage;
	script.onload = onLoadLanguage;
	
	currentLanguage = langName;	
    head.appendChild(script);	
}

function updateButtons()
{
	if(currentPage >= pageCount)
		$("#next_button").addClass("unselectable");
	else
		$("#next_button").removeClass("unselectable");
	if(currentPage <= 1)
		$("#prev_button").addClass("unselectable");
	else
		$("#prev_button").removeClass("unselectable");
}

function onFinishLoadPresentation()
{
	currentPage = 1;
	loadPage(currentPage);	
}
function firstPage()
{
	loadPresentation("main");
}
function prevPage()
{
	currentPage--;
	if(currentPage < 1)
		currentPage = 1;
	else
		loadPage(currentPage);
}

function nextPage()
{
	currentPage++;	
	if(currentPage > pageCount)	
		currentPage = pageCount;	
	else	
		loadPage(currentPage);	
}

function loadComplete()
{
	$('#content').animate({opacity: 1},500);
	applyLanguage(currentLanguage);
	$("#"+currentPresentation).addClass("active");
}

function loadPage(id)
{
	$('#content').animate({opacity: 0},500, function(){
		$('#content').load("presentation/"+currentPresentation+"/page"+currentPage+".html", loadComplete);		
		$('#pos').text(currentPage+"/"+pageCount);
	});	
	updateButtons();
}

function loadPresentation(presName)
{
	var head = document.getElementsByTagName('head')[0];
    var script = document.createElement('script');
    script.type = 'text/javascript';
    script.src = "presentation/"+presName+"/"+presName+".js";
	script.onreadystatechange = onFinishLoadPresentation;
    script.onload = onFinishLoadPresentation;
	if(currentPresentation != "")
		$("#"+currentPresentation).removeClass("active");
    currentPresentation = presName;	
    head.appendChild(script);	
}